Leetcode:find_minimum_in_rotated_sorted_array

简介:

一、     题目

给定一个排好序的数组。数组可能是单调递增,也可能有一个变换。

(i.e., 0 1 2 4 5 6 7 might become 4 5 6 7 0 1 2)

要求找出最小的数。

二、     分析

这道题正如题目所说的分来两种情况

1、         严格单调递增

2、         有一个拐点

  我们须要分情况处理。当然也能够无论这些直接遍历,即从头到尾扫描,找出最小的数;假设依据题意,我们须要考虑

1、         当严格单调时,因为是排好序的所以我们直接return 第一个元素就可以;或者直接利用二分法查找也能够。

2、         当有拐点时,我们就能够二分查找高速找到最小值。

综上所诉。考虑两种情况能够提高效率,可是直接当做一种情况更优点理。

并且都能通过。

 

 

};






本文转自mfrbuaa博客园博客,原文链接:http://www.cnblogs.com/mfrbuaa/p/5153337.html,如需转载请自行联系原作者

相关文章
Leetcode Find Minimum in Rotated Sorted Array 题解
对一个有序数组翻转, 就是随机取前K个数,移动到数组的后面,然后让你找出最小的那个数,注意,K有可能是0,也就是没有翻转。
47 0
LeetCode 153. Find Minimum in Rotated Sorted Array
假设按照升序排序的数组在预先未知的某个点上进行了旋转。 ( 例如,数组 [0,1,2,4,5,6,7] 可能变为 [4,5,6,7,0,1,2] )。 请找出其中最小的元素。 你可以假设数组中不存在重复元素。
105 0
LeetCode 153. Find Minimum in Rotated Sorted Array
|
算法
LeetCode Find Minimum in Rotated Sorted Array II
假设按照升序排序的数组在预先未知的某个点上进行了旋转。 ( 例如,数组 [0,1,2,4,5,6,7] 可能变为 [4,5,6,7,0,1,2] )。 请找出其中最小的元素。 注意数组中可能存在重复的元素。
84 0
LeetCode Find Minimum in Rotated Sorted Array II
|
索引
LeetCode 81. Search in Rotated Sorted Array II
假设按升序排序的数组在事先未知的某个枢轴处旋转。 (例如, [0,0,1,2,2,5,6] 可能变成 [2,5,6,0,0,1,2]). 给定一个要搜索的目标值T, 如果该目标值能在数组中找到则返回true,否则返回false。
88 0
LeetCode 81. Search in Rotated Sorted Array II
LeetCode - 33. Search in Rotated Sorted Array
33. Search in Rotated Sorted Array  Problem's Link  ---------------------------------------------------------------------------- ...
747 0
|
C++ Python
[LeetCode] Find Minimum in Rotated Sorted Array
As explained in the Solution tag, the key to solving this problem is to use invariants. We set two pointers: l for the left and r for the right.
729 0
|
Perl
[LeetCode] Find Minimum in Rotated Sorted Array II
This problem is more or less the same as Find Minimum in Rotated Sorted Array. And one key difference is as stated in the solution tag.
788 0
|
C++
[LeetCode] Search in Rotated Sorted Array II
For those who have already solved Search in Rotated Sorted Array, this problem can be solved similarly using codes for that problem and simply adding codes to skip the duplicates.
887 0
|
C++ Python
[LeetCode] Search in Rotated Sorted Array
This problem is a nice application of binary search. The key lies in how to determine the correct half for target.
570 0